// Copyright 2013, University of Freiburg,
// Image Analysis Lab
// Author: Olaf Ronneberger <ronneber>

/**
 * Class for sorting algorithms, currently only MinSort.
 */
#include <vector>
#include "./Sorter.h"

/**
 * Sort the given array using MinSort.
 */
void Sorter::minSort(std::vector<int>* arrayP) {
  std::vector<int>& array = *arrayP;
  int n = array.size();
  for (int i = 0; i < n - 1; i++) {
    // Compute the minimum among array[i], ..., array[n-1].
    int min = array[i];
    int minIndex = i;
    for (int j = i + 1; j < n; j++) {
      if (array[j] < min) {
        min = array[j];
        minIndex = j;
      }
    }
    // Swap array[i] and array[minIndex].
    int tmp = array[i];
    array[i] = array[minIndex];
    array[minIndex] = tmp;
  }
}
